import cx from "classnames";
import PropTypes from "prop-types";
import { Component } from "react";

import CS from "metabase/css/core/index.css";
import { PLUGIN_LOGO_ICON_COMPONENTS } from "metabase/plugins";

class DefaultLogoIcon extends Component {
  static defaultProps = {
    height: 32,
  };
  static propTypes = {
    width: PropTypes.number,
    height: PropTypes.number,
    dark: PropTypes.bool,
    fill: PropTypes.string,
  };

  render() {
    const { dark, height, width, fill = "currentcolor" } = this.props;
    return (
      <svg
        className={cx(
          "Icon",
          { [CS.textBrand]: !dark },
          { [CS.textWhite]: dark },
        )}
        viewBox="0 0 153.60001 153.60001"
        width={width}
        height={height}
        fill={fill}
        data-testid="main-logo"
      >
        <path d="m 109.94304,1.9925535 c 0,10.9961355 0.30797,22.0895515 0.30372,33.1053375 -10e-4,3.245538 0.93151,10.621042 -1.13651,13.278884 -0.90994,1.169621 -2.97796,1.292019 -4.33042,1.527401 -3.64554,0.634773 -7.282879,1.317837 -10.933881,1.92254 -10.200392,1.689587 -20.425081,3.269228 -30.675586,4.617132 -5.111585,0.672129 -10.32522,1.733322 -15.489652,1.736663 0,-13.053829 1.89976,-26.213657 3.356091,-39.17971 C 51.39276,15.831283 51.94401,12.695084 52.646511,9.58552 52.974223,8.133623 53.610818,5.9335459 52.964504,4.4914299 52.145375,2.6642881 47.817688,2.9069897 46.162117,2.9037095 40.63869,2.8927149 35.293849,2.736725 29.761309,3.1813996 c -1.823284,0.1465746 -4.889935,0.040577 -5.901652,1.8813859 -1.408769,2.5632022 -0.870215,5.9877225 -1.135453,8.7747965 -0.67787,7.123237 -0.558327,14.410997 -0.871552,21.564028 -0.598599,13.670377 -1.759441,27.350171 -2.694317,41.002022 -0.697551,10.186118 -0.739495,20.533512 -1.936207,30.675588 -1.323667,11.21845 -1.454873,22.58907 -3.679309,33.71276 -0.833798,4.16945 -3.009943,9.51581 2.551146,10.23866 5.570807,0.72377 11.693051,0.15338 17.311968,0.0866 1.867263,-0.0222 5.344841,-0.0225 6.888947,-1.19483 1.100677,-0.83583 0.934239,-3.03414 1.033859,-4.27089 0.301288,-3.74819 0.653906,-7.48636 0.91237,-11.23759 0.767497,-11.14495 1.862403,-22.26622 2.679103,-33.40904 0.259679,-3.540146 0.564917,-7.11917 1.117381,-10.630158 0.188913,-1.199385 0.200454,-2.87986 0.957321,-3.879095 1.645244,-2.173107 7.56381,-2.403629 10.101076,-2.827013 9.099715,-1.51829 18.197304,-2.99406 27.33468,-4.267249 5.154713,-0.718294 10.334939,-1.232794 15.489655,-1.911605 2.013045,-0.265146 5.612725,-1.156864 7.523725,-0.295518 1.52861,0.689441 0.9804,3.637335 0.9804,4.980076 0,4.966104 -0.29582,9.938282 -0.30372,14.882218 -0.0206,12.894064 -1.30994,26.060574 -2.74865,38.875984 -0.36021,3.20848 -0.91845,6.29942 -1.76127,9.41527 -0.32983,1.22035 -1.08762,3.19421 -0.47015,4.42427 0.76628,1.52649 5.61363,1.32756 7.1061,1.34517 5.36398,0.0638 10.73251,10e-4 16.09709,10e-4 2.40758,0 5.73239,0.36628 7.88332,-0.93849 3.09581,-1.87759 0.79058,-6.40756 0.4082,-9.08423 -1.03689,-7.25705 -0.56522,-16.06824 -0.0638,-23.38634 1.93044,-28.19055 1.71297,-56.533274 3.64463,-84.737503 0.4826,-7.049341 0.71495,-14.274991 1.88153,-21.260308 0.38542,-2.30723 2.16673,-6.3023445 0.59924,-8.4392185 -1.63735,-2.2314759 -5.89275,-1.5834981 -8.27876,-1.5834981 -7.50641,0 -14.98275,0.3037186 -22.47519,0.3037186 z"></path>
      </svg>
    );
  }
}

export default function LogoIcon(props) {
  const [Component = DefaultLogoIcon] = PLUGIN_LOGO_ICON_COMPONENTS;
  return <Component {...props} />;
}
